/* Static structures for translate.c.
   Copyright (C) 1992-1997 Jean Goubault-Larrecq and Bull S.A.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct compileconstant {
  ExprPtr e;
  ExprPtr last;
  Boolean boxedp;
};

struct constantpattern {
  ExprPtr pat;
  ExprPtr memoref;
  Boolean constp;
};

struct compilevectormatch {
  ExprPtr pat,val;
  COUNTER idx;
  compEnv *env;
  ExprPtr last;
  ExprPtr choicelast,errlast;
};

struct patmapadd {
  ExprPtr pat;
  ExprPtr map;
  ExprPtr choicelast;
};

struct compilepattern {
  ExprPtr pat,val;
  compEnv *env;
  ExprPtr last;
  ExprPtr choicelast,errlast;
};

struct dumpletstores {
  ExprPtr last;
  ExprPtr env;
};

struct compilebinding {
  ExprPtr binding;
  compEnv *env;
  ExprPtr last;
  ExprPtr errlast;
};

struct compilesimpleofk {
  struct compilesimpleof *data;
  compEnv *env;
  ExprPtr last;
  ExprPtr nonelast;
  ExprPtr errlast;
};

struct compiledomainssimplek {
  ExprPtr domains;
  compEnv *env;
  ExprPtr last;
  ExprPtr locals;
};

struct translatestmt {
  ExprPtr e;
  compEnv *env;
  ExprPtr last;
};
