/* Initialization for the translator from interpreted form to SSA.
   Copyright (C) 1992-1997 Jean Goubault-Larrecq and Bull S.A.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#if TRANSLATOR
#include "eval.h"
#include "expr.h"
#include "translate.h"
#include "optimize.h"
#include "trlproto.h"
#ifdef HAS_STRING_H
#include <string.h>
#else
#include <strings.h>
#endif
#ifdef HAS_PROTOTYPES
#include "strlinit.h"
#endif

#define __SEG__ INIT

EXTERN extDesc codeDesc,ppInfoDesc,ppDecoDesc,vnInfoDesc,vfInfoDesc;

PUBLIC void InitOpt()
{
  registerExtDesc(&codeDesc);
  registerExtDesc(&ppInfoDesc);
  registerExtDesc(&ppDecoDesc);
  registerExtDesc(&vnInfoDesc);
  registerExtDesc(&vfInfoDesc);
}
#endif
