
(* There was once a bug with inlining. It worked as follows:
 The function notinlined below is too big to be inlined, although
 inlined can be inlined. Now, if you typed these definitions at
 the toplevel, everything would work well; but if you did
 open "inl1", then inlined 3, it would core dump.
 *)

fun notinlined x =
    let val y=x+1
	val z = card {t*t | t in set 1 to y}
	exception Gag
	val u = y*z+2
	val u1 = [u,u,u,u,u,u,u,u,u,u,u]
	val w = len u1+3
	val v = [x,x,x,x,x,x,x,x,x,x,x,x]
	val w' = len v*2
    in
	(y,z,Gag,u,w,w')
    end;

fun inlined x = #1 (notinlined x)+1;
