/* Prototypes for initialization functions.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

typedef NORETURN void (*mainAction) P((int argc,char **argv)) _NORETURN;

IMPORT NORETURN void InitML P((mainAction main,int argc,char **argv)) _NORETURN;
#if TRANSLATOR
IMPORT void InitBC P((void));
#endif
#if DEBUGGING
IMPORT void InitDebug P((void));
#endif
IMPORT void InitHlex P((void));
IMPORT void InitHyacc P((void));
IMPORT void InitLIP P((void));
