/* static declarations for file gramaux.c */
static void TextToReal P((struct yyltype *, struct yyltype *, unsigned char *, double *));
static ExprPtr cons P((ExprPtr, ExprPtr));
static ExprPtr Cons P((ExprPtr, ExprPtr));
static void newBucket P((void));
static ExprPtr gensym P((void));
static ExprPtr build1MatchFun P((ExprPtr));
static ExprPtr build1ArgFun P((struct yyltype *, struct yyltype *, ExprPtr));
static void patchMemoFun P((ExprPtr));
static char *errorMsg P((char *, ExprPtr));
static void checkQuantifiedType1 P((ExprPtr, ExprPtr));
static ExprPtr addTyVar P((ExprPtr, ExprPtr));
static ExprPtr exprTyVars1 P((ExprPtr, ExprPtr));
static void basisSweep P((char *, doExtDesc *));
static ExprPtr basisLoad P((extDesc *, Boolean, ExprPtr, loadAction));
static void saveBisonState P((struct bisonstate *));
static void loadBisonState P((struct bisonstate *));
static ExprPtr preCompile1 P((char *));
static ExprPtr getModuleName P((unsigned char *));
static ExprPtr do_trimcons P((ExprPtr, ExprPtr, unsigned char *));
static void trimTable P((ExprPtr, ExprPtr, ExprPtr));
static void trimState P((ExprPtr, ExprPtr));
static void trimEnv P((ExprPtr, ExprPtr));
static void outI P((long, hFILE *));
static void outDepend P((ExprPtr, hFILE *));
static void recordOpenMod P((char *, Boolean));
static void readfile P((unsigned char *, int, char *));
static long inI P((hFILE *));
static Boolean checkOpenMods P((time_t, hFILE *));
static Boolean skipOpenMods P((hFILE *));
static hFILE *openModule P((unsigned char *, char **, ExprPtr *, Boolean));
static Boolean do_errconsenv P((ExprPtr, ExprPtr, unsigned char *));
static void augmentLexicalEnv1 P((ExprPtr, ExprPtr));
static void checksumPrint P((unsigned char *, int, char *));
static ExprPtr S P((long));
