/* static declarations for file print.c */
static int printQuote P((printFunc, char *));
static int printOpenBracket P((printFunc, char *));
static int printCloseBracket P((printFunc, char *));
static int printNil P((printFunc, char *));
static int printTuple0 P((printFunc, char *));
static int printColon P((printFunc, char *));
static int printEmpty P((printFunc, char *));
static int printMapsto P((printFunc, char *));
static int printRef P((printFunc, char *));
static int printFn P((printFunc, char *));
static int printBeginSpecial P((printFunc, char *));
static int printEndSpecial P((printFunc, char *));
static int printPromise P((printFunc, char *));
static int printContinuation P((printFunc, char *));
static int printDynamic P((printFunc, char *));
static int printOpenArray P((printFunc, char *));
static int printCloseArray P((printFunc, char *));
static int printEscape P((printFunc, char *));
static void intPrint P((long, printFunc, char *));
static void listPrintNoType P((ExprPtr, printFunc, char *));
static void tuplePrintNoType P((ExprPtr, printFunc, char *));
static Boolean do_printmapnotype P((ExprPtr, ExprPtr, unsigned char *));
static Boolean do_dumpshape P((ExprPtr, ExprPtr, unsigned char *));
static void dumpShape P((ExprPtr, ExprPtr *));
static void recordPrintNoType P((ExprPtr, printFunc, char *));
static void dataPrintNoType P((ExprPtr, printFunc, char *, int));
static void valPrtN1 P((ExprPtr, printFunc, char *, int));
static void printComplexException P((ExprPtr, printFunc, char *, int));
static void arrayPrint P((ExprPtr, ExprPtr, printFunc, char *));
static void listPrint P((ExprPtr, ExprPtr, printFunc, char *));
static void tuplePrint P((ExprPtr, ExprPtr, printFunc, char *));
static Boolean do_printmap P((ExprPtr, ExprPtr, unsigned char *));
static void mapPrint P((ExprPtr, ExprPtr, ExprPtr, printFunc, char *));
static void recordPrint P((ExprPtr, ExprPtr, printFunc, char *));
static void dataPrint P((ExprPtr, ExprPtr, ExprPtr, printFunc, char *, int));
static Boolean do_printnum P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr getValue P((int, register int, ExprPtr));
static Boolean dataCheckTypeTag P((ExprPtr, ExprPtr));
static Boolean checkTupleTag P((ExprPtr, ExprPtr));
static void valPrt1 P((ExprPtr, ExprPtr, printFunc, char *, int));
static void printoverflow P((unsigned char *, int, char *));
static Boolean printOverflow P((ExprPtr, ExprPtr, int, int, int));
static long stringCut P((unsigned char *, long, int, int));
static Boolean stringPretty P((unsigned char *, long, printFunc, char *, int, int));
static Boolean listPretty P((ExprPtr, ExprPtr, printFunc, char *, int, int));
static Boolean tuplePretty P((ExprPtr, ExprPtr, printFunc, char *, int, int));
static Boolean do_prettymap P((ExprPtr, ExprPtr, unsigned char *));
static Boolean mapPretty P((ExprPtr, ExprPtr, ExprPtr, printFunc, char *, int, int));
static Boolean dataPretty P((ExprPtr, ExprPtr, ExprPtr, printFunc, char *, int, int, int));
static Boolean recordPretty P((ExprPtr, ExprPtr, printFunc, char *, int, int));
static Boolean arrayPretty P((ExprPtr, ExprPtr, printFunc, char *, int, int));
static Boolean valPretty1 P((ExprPtr, ExprPtr, printFunc, char *, int, int, int));
static Boolean dynPrintOverflow P((ExprPtr, int, int, int));
static Boolean do_valprint P((ExprPtr, ExprPtr, unsigned char *));
static Boolean do_dumprectype P((ExprPtr, ExprPtr, unsigned char *));
static int cmpstr P((const void *, const void *));
static void dumpRecTypes P((ExprPtr, long, field *));
static Boolean do_typeprintnum P((ExprPtr, ExprPtr, unsigned char *));
static void ellipsisPrint P((ExprPtr, printFunc, char *));
static int printSet P((printFunc, char *));
static void TypePrint1k P((ExprPtr, printFunc, char *, ExprPtr, int));
static void TypePrint1 P((ExprPtr, printFunc, char *, ExprPtr, int));
static void nilprint P((unsigned char *, int, char *));
static Boolean printTypeOverflow P((ExprPtr, int, int, ExprPtr, int));
static Boolean TypePretty1k P((ExprPtr, printFunc, char *, ExprPtr, int, int, int));
static Boolean TypePretty1 P((ExprPtr, printFunc, char *, ExprPtr, int, int, int));
static Boolean do_idsprint P((ExprPtr, ExprPtr, unsigned char *));
static Boolean idsPrint P((ExprPtr, printFunc, char *, ExprPtr));
static Boolean do_tyfcnsprint P((ExprPtr, ExprPtr, unsigned char *));
static Boolean tyfcnsPrint P((ExprPtr, printFunc, char *, ExprPtr));
static Boolean do_unitsprint P((ExprPtr, ExprPtr, unsigned char *));
static Boolean unitsPrint P((ExprPtr, printFunc, char *, ExprPtr));
static void do_printstring P((unsigned char *, int, char *));
static void terminateString P((struct printstring *));
static void crString P((struct printstring *));
