/* static declarations for file type.c */
static void setq P((ExprPtr *, ExprPtr));
static void setcar P((ExprPtr, ExprPtr));
static void setcdr P((ExprPtr, ExprPtr));
static ExprPtr Cons P((ExprPtr, ExprPtr));
static ExprPtr tcString P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcNumber P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcNonSense P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcVariable P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcUnitPower P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcUnitStar P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcSetUnit P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcLabel P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcRecordMaplet P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcRecord P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcTuple1 P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcTuple P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcProgn P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcList P((ExprPtr, ExprPtr, ExprPtr));
static void checkRep P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcDeclList1 P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr beginAssum P((ExprPtr));
static void endAssum P((ExprPtr, ExprPtr));
static void updateAssum P((ExprPtr, ExprPtr));
static ExprPtr tcOfMap1 P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcListOfMap P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcInSet P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcInList P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcMaplet P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcMap P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcMapOfMap P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcProgOf P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcQuantOfMap P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcSomeOf P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcLet P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcApply1 P((TZone *, TZone *, ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static Boolean complexFn P((ExprPtr, ExprPtr));
static ExprPtr tcApply P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcCast P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcBoolBin P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcHandle P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcRaise P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcMatch P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcFn P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcLambda P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcIf P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcWhile1 P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcWhile P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcWhileList P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcWhileMap P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcWhileBool P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcWhileSome P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcDeclList P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcLocal P((ExprPtr, ExprPtr, ExprPtr));
static Boolean do_checkidexts P((ExprPtr, ExprPtr, unsigned char *));
static void checkIdExts P((ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcVal1 P((ExprPtr, ExprPtr, ExprPtr, Boolean));
static ExprPtr tcVal P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcValRec P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatTuple1 P((ExprPtr, ExprPtr, ExprPtr, ExprPtr *, ExprPtr *));
static ExprPtr tcPatTuple P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcDecl P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcNewQuan P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcUnit P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcNewUnit P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcType P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcTypeBind P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr letrecDatatype P((ExprPtr, ExprPtr, ExprPtr, ExprPtr *));
static ExprPtr tcDataType P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcDataTypeBind P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcAbsType P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcTypeVarSeq P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcConstructor P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcException P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcNewExc P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcExcBind P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcMapletType P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcRecordType P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcTypeApply P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcTypePower P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcTypeStar P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcTupleType1 P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcTupleType P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcFunctionType P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcMapType P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatAny P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatRecordEllipsis P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcIllegal P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatRecordMaplet P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatRecord1 P((ExprPtr, ExprPtr, ExprPtr, ExprPtr *, ExprPtr *));
static ExprPtr tcPatRecord P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatAs P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatCast P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatAnyList P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatApply P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatAnyMap P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatMaplet P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatMapAdd P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPrimeDataBind P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr do_patchconsinfo P((ExprPtr, ExprPtr, unsigned char *));
static void patchConsInfo P((ExprPtr, ExprPtr));
static ExprPtr tcUnitName P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcTypeVar P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcRealVar P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatVar P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatConst P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcSelectFn P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcMu P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcSubMap P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcDelay P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPack1 P((ExprPtr, ExprPtr, ExprPtr, Boolean));
static ExprPtr tcPack P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPatPack P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcInteger P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcTypeEllipsis P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcExtDatatype1 P((ExprPtr, ExprPtr, ExprPtr, Boolean));
static void checkExtern P((ExprPtr, ExprPtr));
static ExprPtr tcExtDatatype P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcExtEqtype P((ExprPtr, ExprPtr, ExprPtr));
static Boolean do_check_extquan P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr tcExtQuantity P((ExprPtr, ExprPtr, ExprPtr));
static Boolean do_extvalerr P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr tcExtVal P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcMemoFn P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcEqtypeInfo P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr do_nondummytycons P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr nonDummyTyCons P((ExprPtr));
static void untrimState P((ExprPtr, ExprPtr));
static Boolean do_checkimports P((ExprPtr, ExprPtr, unsigned char *));
static Boolean do_checkdatatypes P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr tcBasis P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcEnterFile P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcExitFile P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcPragma P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcValSpec P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcValSpecBind P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcTypeSpec1 P((ExprPtr, ExprPtr, ExprPtr, typeSpecTag, Boolean));
static ExprPtr tcTypeSpec P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr tcTypeSpecBind P((ExprPtr, ExprPtr, ExprPtr));
static ExprPtr typecheck1 P((ExprPtr, ExprPtr, ExprPtr));
