/* Stack and continuation handling functions, prototypes.
   This is mostly black magic.
   Copyright (C) 1992-1997 Jean Goubault-Larrecq and Bull S.A.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

typedef CONST ExprPtr (*mlAction) P((INOUT char *data));

IMPORT ExprPtr doML P((IN mlAction fun,
		       INOUT char *data));
typedef NORETURN void (*loweredStackAction) P((char *data));

IMPORT void InitStack P((loweredStackAction fun));

IMPORT NORETURN void stackJmp P((IN CONST StackChunk *chunk,
				 IN CONST stackDesc *jb,
				 IN CONST int data));
#if OS==UNIX_SYS_V || OS==UNIX_BSD
IMPORT void expandStack P((IN CONST char *mark));
#endif

IMPORT void flushstk P((IN mlAction fun,
			INOUT char *data));

IMPORT void setHandlerStack P((IN CONST ExprPtr stack));
IMPORT void resetHandlerStack P((void));
