
#define zdiv21(numhigh, numlow, denom, quot, rem) \
{ \
	register long lr21; \
	register long lq21 = (long) (((fradix * (EXTENDED) (numhigh)) \
			 + (EXTENDED) (numlow)) / (EXTENDED) (denom)); \
\
/* Following works in many two's complement architectures. */ \
	lr21 = (numhigh << NBITS) + numlow - lq21 * denom; \
	if (lr21 < 0) \
	{ \
		do \
		{ \
			lq21--; \
		} while ((lr21 += denom) < 0); \
	} \
	else \
	{ \
		while (lr21 >= denom) \
		{ \
			lr21 -= denom; \
			lq21++; \
		}; \
	} \
	*quot = lq21; \
	*rem = lr21; \
}
