/* static declarations for file gc.c */
static char *gcFlushName P((int));
static void flushGCMark P((void));
static void unflushGCMark P((void));
static void pushGCVector P((register ExprPtr *, register ExprPtr *));
static void markGCVector P((int, register ExprPtr *));
static void GCmarkStackView P((gcStackView *));
static void GCmarkStackViewOff P((gcStackView *, StackChunk *));
static void GCMark1 P((register ExprPtr));
static void GCmarkExcHandler P((register excHandler *));
static void GCmarkByteCode P((byteCodeChunk *));
static void GCmark1 P((register ExprPtr));
static void PairFree P((void));
static void IntFree P((void));
static void SlotsFree1 P((register ExprPtr *));
static void RealFree P((void));
static void StringFree P((void));
static void VarFree P((void));
static void RefFree P((void));
static void ExtFree P((void));
static void ArrayFree P((void));
static void DataFree P((void));
static void AllocFrees P((void));
static void ExpandTables P((unsigned long, unsigned long, unsigned long, unsigned long, unsigned long, unsigned long, unsigned long, unsigned long, unsigned long));
static void donothing P((ExprPtr));
static void sweepHomoBucket P((BucketPtr, register ExprPtr *));
static void sweepHeteroBucket P((BucketPtr, register ExprPtr *));
static void GCsweep1 P((void));
static void cutoffOldBuckets1 P((BucketPtr));
static void cutoffOldBuckets P((void));
static void cutoffOldGenerations P((void));
static unsigned int gcRandom P((void));
static void refreshGenerationCount P((int));
static void refreshOldBuckets1 P((BucketPtr, int));
static void refreshOldBuckets P((int));
static void refreshWriteBarrier P((void));
static void refreshOldGenerations P((int));
static void resetCurrentBucket P((void));
static void GCsweep P((void));
